<?php

/*******************************************************************************
Copyright (c) 2019 Clear Admin Software Kft.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met: 

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/

//tested with Wordpress 5.3 and WooCommerce 3.8.1




$vat_percent = 27;
$order_complete_status = "wc-completed"; 
$post_type_order = "shop_order";

//Csatlakozas adatbazishoz
require_once(dirname(__FILE__).'/../wp-config.php');

//$conn = mysqli_connect(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD);
$conn = mysqli_connect(DB_HOST, DB_USER, DB_PASSWORD);

/* check connection */
if (mysqli_connect_errno()) {
    printf("Connect failed: %s\n", mysqli_connect_error());
    exit();
}

if(!mysqli_select_db($conn, DB_NAME))
{
	show_error("DB select: " . mysqli_error($conn));
}

//if(!mysqli_query($conn, 'SET NAMES utf-8'))
if(!mysqli_query($conn, 'SET CHARACTER SET '.DB_CHARSET))
{
	show_error("Unable to set character set. ".mysqli_error($conn));
}


$last_orderhead_timestamp = $_GET['last_orderhead_timestamp'];

$max_orders = $_GET['max_orders'] + 0;
if(!$max_orders)
	$max_orders = 30;


$table_name = $table_prefix . "posts";
$q = "select * from $table_name where post_type = '$post_type_order' and post_status = '$order_complete_status' and
	post_modified  >= '$last_orderhead_timestamp' order by post_modified limit $max_orders";
	

$res = mysqli_query($conn, $q);
if(!$res)
	show_error("select order: [$q] " . mysqli_error($conn));


print '<'.'?xml version="2.0" encoding="UTF-8" standalone="yes" ?'.'>' . "\n";

print "<!DOCTYPE ORDERS>\n";
print "<ORDERS>\n";

while($order_ary = mysqli_fetch_assoc($res))
{
	show_order($order_ary);
}

?>
</ORDERS>
<?php



function show_order($order)
{

	global $table_prefix;
	$table_name = $table_prefix . "postmeta";
	$q = "select * from $table_name where post_id = '$order[ID]'";
	$userinfos = db_get_records($q);

	$table_name = $table_prefix . "woocommerce_order_items";
	$q = "select * from $table_name where order_id = '$order[ID]'";
	$items = db_get_records($q);

	$today_str = date('Y-m-d');
	
	foreach($userinfos as $userinfo){
		//print_r($userinfo);
		if($userinfo['meta_key']=='_billing_first_name')	$user['fname'] = $userinfo['meta_value'];
		if($userinfo['meta_key']=='_billing_last_name') 	$user['lname'] = $userinfo['meta_value'];
		if($userinfo['meta_key']=='_billing_postcode') 		$user['zip'] = $userinfo['meta_value'];
		if($userinfo['meta_key']=='_billing_address_1') 	$user['address1'] = $userinfo['meta_value'];
		if($userinfo['meta_key']=='_billing_address_2') 	$user['address2'] = $userinfo['meta_value'];
		if($userinfo['meta_key']=='_billing_company') 		$user['company'] = $userinfo['meta_value'];
		if($userinfo['meta_key']=='_billing_city') 			$user['city'] = $userinfo['meta_value'];

		if($userinfo['meta_key']=='_payment_method') 		$user['paymentmethod_code'] = $userinfo['meta_value'];
		
		if($userinfo['meta_key']=='_billing_email') 		$user['email'] = $userinfo['meta_value'];

//		if($userinfo['meta_key']=='_payment_method_title') 	$user['paymentmethod_name'] = $userinfo['meta_value'];
//		if($userinfo['meta_key']=='_completed_date')		$user['completed_date_str'] = date_create($userinfo['meta_value']);		
	}
	?>

		<ORDER>
			<ORDERHEAD_CODE><?php echo he($order['ID'])?></ORDERHEAD_CODE>
			<ORDERHEAD_TIMESTAMP><?php echo he($order['post_modified'])?></ORDERHEAD_TIMESTAMP>

			<ORDERHEAD_PARTNER_NAME><?php echo he(strlen($user['company']) ? $user['company'] : $user['fname'].' '.$user['lname'])?></ORDERHEAD_PARTNER_NAME>
			<ORDERHEAD_PARTNER_ZIP><?php echo he($user['zip'])?></ORDERHEAD_PARTNER_ZIP>
			<ORDERHEAD_PARTNER_CITY><?php echo he($user['city'])?></ORDERHEAD_PARTNER_CITY>
			<ORDERHEAD_PARTNER_ADDRESS><?php echo he($user['address1'].' '.$user['address2'])?></ORDERHEAD_PARTNER_ADDRESS>

			<ORDERHEAD_PARTNER_CONTACT_EMAIL><?php echo he($user['email'])?></ORDERHEAD_PARTNER_CONTACT_EMAIL>
			<ORDERHEAD_PARTNER_CONTACT_NAME><?php echo he($user['fname'].' '.$user['lname'])?></ORDERHEAD_PARTNER_CONTACT_NAME>

			<ORDERHEAD_PAYMENTMETHOD_CODE><?php echo he($user['paymentmethod_code'])?></ORDERHEAD_PAYMENTMETHOD_CODE>

			<ORDERHEAD_DATE_SHIPPED><?php echo date("Y-m-d", strtotime($order['post_modified']))?></ORDERHEAD_DATE_SHIPPED>

			<ORDERHEAD_SUBJECT>Internetes vásárlás - megrendelés azonosítója: <?php echo $order['ID']+0?></ORDERHEAD_SUBJECT>

			<ORDERHEAD_VERIFIED>1</ORDERHEAD_VERIFIED>
			<?php
			
				show_orderitems($items);
				
			?>

		</ORDER>
	<?php
}

function show_orderitems($items)
{
	global $table_prefix;
	global $vat_percent;
	if(!$items)
		return;
	foreach($items as $item)
	{
		$table_name = $table_prefix . "woocommerce_order_itemmeta";
		//$q = "select * from $table_name where order_item_id = '$item[order_item_id]' order by meta_key";
		$q = "select * from $table_name where order_item_id = '$item[order_item_id]'";
		$metas = db_get_records($q);		
		
		foreach($metas as $meta){
			switch ($meta['meta_key']) {
				case '_qty' : $item['item_qty'] = $meta['meta_value'];
				case '_line_total' : $item['_line_total'] = $meta['meta_value'];
				case 'cost' : $item['cost'] = $meta['meta_value'];
			}
		}
		
		//ÁFA rendelési tétel kihagyása
		if($item['order_item_type']=='tax')
			return;
		
		$comment_str = '';

		//statisztikai szamjel (VTSZ/SZJ)
		$statno = '';
		
		//Utánvét díj tétel kezelése
		if($item['order_item_type']=='fee'){
			$name = 'Utánvét díja';
			$item['item_qty'] = 1;
			$price = $item['cost']/1.27;
		}
		
		//Szállítási tétel kezelése
		if($item['order_item_type']=='shipping'){
			$name = 'Szállítási költség - '.he($item['order_item_name']);
			$item['item_qty'] = 1;
			$price = $item['cost'];
		}else{
			$name = he($item['order_item_name']);
			$price = $item['_line_total'] / $item['item_qty'];
		}
		
		$unit = 'db';
		$vat_code = $vat_percent;
		
		?>

			<ORDERITEM>
				<ORDERITEM_CODE><?php echo he($item['order_item_id']).'_'.he($item['order_id'])?></ORDERITEM_CODE>

				<ORDERITEM_PRODUCT_CODE><?php echo he($item['order_item_name'])?></ORDERITEM_PRODUCT_CODE>
				<ORDERITEM_STAT_NO><?php echo  $statno ?></ORDERITEM_STAT_NO>
				<ORDERITEM_NAME><?php echo $name ?></ORDERITEM_NAME>
				<ORDERITEM_COMMENT><?php echo $comment_str?></ORDERITEM_COMMENT>
				<ORDERITEM_UNIT><?php echo $unit?></ORDERITEM_UNIT>
				<ORDERITEM_VAT_CODE><?php echo $vat_code?></ORDERITEM_VAT_CODE>
				<ORDERITEM_VAT_PERCENT><?php echo $vat_percent?></ORDERITEM_VAT_PERCENT>
				<ORDERITEM_VAT_NAME><?php echo ($vat_percent+0).'%'?></ORDERITEM_VAT_NAME>

				<ORDERITEM_LIST_PRICE><?php echo $price?></ORDERITEM_LIST_PRICE>
				<ORDERITEM_QTY><?php echo he($item['item_qty'])?></ORDERITEM_QTY>
			</ORDERITEM>
		<?php
	}
}


function he($s)
{
	//return htmlentities($s);
	return $s;
}

function show_error($error_str)
{
	echo($error_str);
	die();
}

function db_get_record($q)
{
	global $conn;
	$res = mysqli_query($conn, $q);
	if(!$res)
		show_error("db_get_record(): [$q] " . mysqli_error($conn));
	return mysqli_fetch_assoc($res);
}

function db_get_field($q)
{
	global $conn;
	$res = mysqli_query($conn, $q);
	if(!$res)
		show_error("db_get_field(): [$q] " . mysqli_error($conn));
	$row = mysqli_fetch_row($res);
	if($row == FALSE) return FALSE;
	return $row[0];
}

function db_get_records($q)
{
	global $conn;
	$res = mysqli_query($conn, $q);
	if(!$res)
		show_error("db_get_records [$q] " . mysqli_error($conn));
	$ret_ary = array();
	while($ary = mysqli_fetch_assoc($res))
	{
		$ret_ary[] = $ary;
	}
	if(count($ret_ary))
		return $ret_ary;
	return FALSE;
}

function db_get_map($q)
{
	global $conn;
	$res = mysqli_query($conn, $q);
	if(!$res)
		show_error("db_get_map [$q] " . mysqli_error($conn));
	$ret_ary = array();
	while($ary = mysqli_fetch_row($res))
	{
		$ret_ary[$ary[0]] = $ary[1];
	}
	if(count($ret_ary))
		return $ret_ary;
	return FALSE;
}

function ary_to_utf8($ary)
{
	$res = array();
	foreach($ary as $k => $v)
	{
		if(!is_array($v))
		{
			$res[$k] = mb_convert_encoding($v, 'UTF-8', 'ISO-8859-2');
		}
		else
		{
			$res[$k] = $v;
		}
	}
	return $res;
}

?>
